// If this code works, it was written by Svetlio Kapralov. If not, I don't know who wrote it.
package net.playerfinder.jsf.components.socialshare;

import java.io.IOException;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.render.FacesRenderer;
import javax.faces.render.Renderer;

import net.playerfinder.jsf.components.common.Utils;

@FacesRenderer(componentFamily = UISocialShare.COMPONENT_FAMILY, rendererType = UISocialShare.DEFAULT_RENDERER)
public class UISocialShareRenderer extends Renderer {

	@Override
	public void encodeEnd(FacesContext context, UIComponent component)
			throws IOException {
		UISocialShare socialShare = (UISocialShare) component;

		ResponseWriter writer = context.getResponseWriter();
		String clientId = socialShare.getClientId(context).replace(":", "_");

		writer.startElement("div", null);
		writer.writeAttribute("id", clientId, "id");

		if (socialShare.getLayout() == 2 || socialShare.getLayout() == 3) {
			if (socialShare.isShowGooglePlus()) {
				writer.startElement("div", null);
				writer.writeAttribute("id", clientId + "_googleplus", "id");
				printDataAttributes(context, socialShare, 0);
				writer.endElement("div");
			}
			if (socialShare.isShowFacebook()) {
				writer.startElement("div", null);
				writer.writeAttribute("id", clientId + "_facebook", "id");
				printDataAttributes(context, socialShare, 1);
				writer.endElement("div");
			}
			if (socialShare.isShowTwitter()) {
				writer.startElement("div", null);
				writer.writeAttribute("id", clientId + "_twitter", "id");
				printDataAttributes(context, socialShare, 2);
				writer.endElement("div");
			}
		} else {
			printDataAttributes(context, socialShare, null);
		}

		writer.endElement("div");

		switch (socialShare.getLayout()) {
//			case 0: {
//				encodeLayout_0(context, socialShare);
//				break;
//			}
			case 1: {
				encodeLayout_1(context, socialShare);
				break;
			}
//			case 2: {
//				encodeLayout_2(context, socialShare);
//				break;
//			}
//			case 3: {
//				encodeLayout_3(context, socialShare);
//				break;
//			}
		}
	}

	private void printDataAttributes(FacesContext context,
			UISocialShare socialShare, Integer currentButton)
			throws IOException {
		ResponseWriter writer = context.getResponseWriter();
		if (socialShare.getUrl() != null && socialShare.getUrl().length() > 0)
			writer.writeAttribute("data-url", socialShare.getUrl(), "data-url");
		if (socialShare.getText() != null && socialShare.getText().length() > 0)
			writer.writeAttribute("data-text", socialShare.getText(),
					"data-text");
		if (socialShare.getTitle() != null
				&& socialShare.getTitle().length() > 0
				&& !(socialShare.getLayout() == 2 || socialShare.getLayout() == 3))
			writer.writeAttribute("data-title", socialShare.getTitle(),
					"data-title");

		if (socialShare.getLayout() == 2) {
			if (currentButton != null && currentButton == 0)
				writer.writeAttribute("data-title", "+1", "data-title");
			if (currentButton != null && currentButton == 1)
				writer.writeAttribute("data-title", "Like", "data-title");
			if (currentButton != null && currentButton == 2)
				writer.writeAttribute("data-title", "Tweet", "data-title");
		}
	}

	private String addComma(String s) {
		if (s.length() > 0)
			return s + ", ";
		else
			return s;
	}

	private void encodeLayout_0(FacesContext context, UISocialShare socialShare)
			throws IOException {

		ResponseWriter writer = context.getResponseWriter();
		String clientId = socialShare.getClientId(context).replace(":", "_");
		String jqueryElementId = Utils.escapeIdForJQuery(clientId);

		writer.startElement("script", null);

		writer.write("pf_jQuery(function($) { " + "$('#" + jqueryElementId
				+ "').sharrre({ \n");
		writer.write("share: { \n");
		String showOptions = "";
		if (socialShare.isShowGooglePlus())
			showOptions += "googlePlus: true ";
		if (socialShare.isShowFacebook()) {
			showOptions = addComma(showOptions);
			showOptions += "facebook: true ";
		}
		if (socialShare.isShowTwitter()) {
			showOptions = addComma(showOptions);
			showOptions += "twitter: true ";
		}
		writer.write(showOptions);
		writer.write("}, \n");
		writer.write("buttons: { \n");
		writer.write("googlePlus: {size: 'tall'}, \n");
		writer.write("facebook: {layout: 'box_count'}, \n");
		writer.write("twitter: {count: 'vertical', via: '_JulienH'} \n");
		writer.write("}, \n");
		writer.write("hover: function(api, options){ \n");
		writer.write("$(api.element).find('.buttons').show(); \n");
		writer.write("}, \n");
		writer.write("hide: function(api, options){ \n");
		writer.write("$(api.element).find('.buttons').hide(); \n");
		writer.write("}, \n");
		writer.write("enableTracking: false \n");
		writer.write("}); }); \n");

		writer.endElement("script");

		writer.startElement("style", null);
		writer.writeAttribute("type", "text/css", "type\n");

		writer.write(".sharrre .box{\n");
		writer.write("float:left;\n");
		writer.write("}\n");
		writer.write(".sharrre .count {\n");
		writer.write("color:#444444;\n");
		writer.write("display:block;\n");
		writer.write("font-size:17px;\n");
		writer.write("line-height:34px;\n");
		writer.write("height:34px;\n");
		writer.write("padding:4px 0;\n");
		writer.write("position:relative;\n");
		writer.write("text-align:center;\n");
		writer.write("text-decoration:none;\n");
		writer.write("width:50px;\n");
		writer.write("background-color:#eee;\n");
		writer.write("-webkit-border-radius:4px;\n");
		writer.write("-moz-border-radius:4px;\n");
		writer.write("border-radius:4px;\n");
		writer.write("}\n");
		writer.write(".sharrre .share {\n");
		writer.write("color:#FFFFFF;\n");
		writer.write("display:block;\n");
		writer.write("font-size:11px;\n");
		writer.write("height:16px;\n");
		writer.write("line-height:16px;\n");
		writer.write("margin-top:3px;\n");
		writer.write("padding:0;\n");
		writer.write("text-align:center;\n");
		writer.write("text-decoration:none;\n");
		writer.write("width:50px;\n");
		writer.write("background-color:#9CCE39;\n");
		writer.write("-webkit-border-radius:4px;\n");
		writer.write("-moz-border-radius:4px;\n");
		writer.write("border-radius:4px;\n");
		writer.write("}\n");
		writer.write(".sharrre .buttons {\n");
		writer.write("display:none;\n");
		writer.write("position:absolute;\n");
		writer.write("margin-left:50px;\n");
		writer.write("z-index:10;\n");
		writer.write("background-color:#fff;\n");
		writer.write("}\n");
		writer.write(".sharrre .button {\n");
		writer.write("float:left;\n");
		writer.write("max-width:50px;\n");
		writer.write("margin-left:10px;\n");
		writer.write("}\n");

		writer.endElement("style");

	}

	private void encodeLayout_1(FacesContext context, UISocialShare socialShare)
			throws IOException {

		ResponseWriter writer = context.getResponseWriter();
		String clientId = socialShare.getClientId(context).replace(":", "_");
		String jqueryElementId = Utils.escapeIdForJQuery(clientId);

		writer.startElement("script", null);

		writer.write("pf_jQuery(function($) { " + "$('#" + jqueryElementId
				+ "').sharrre({ \n");
		writer.write("share: { \n");
		String showOptions = "";
		if (socialShare.isShowGooglePlus())
			showOptions += "googlePlus: true ";
		if (socialShare.isShowFacebook()) {
			showOptions = addComma(showOptions);
			showOptions += "facebook: true ";
		}
		if (socialShare.isShowTwitter()) {
			showOptions = addComma(showOptions);
			showOptions += "twitter: true ";
		}
		// if (socialShare.isShowDigg()) {
		// showOptions = addComma(showOptions);
		// showOptions += "digg: true ";
		// }
		// if (socialShare.isShowDelicious()) {
		// showOptions = addComma(showOptions);
		// showOptions += "delicious: true ";
		// }
		if (socialShare.isShowLinkedIn()) {
			showOptions = addComma(showOptions);
			showOptions += "linkedin: true ";
		}
		writer.write(showOptions);
		writer.write("}, \n");
		writer.write("buttons: { \n");
		String buttonOptions = "";
		if (socialShare.isShowGooglePlus())
			buttonOptions += "googlePlus: {size: 'tall', annotation:'bubble'}";
		if (socialShare.isShowFacebook()) {
			buttonOptions = addComma(buttonOptions);
			buttonOptions += "facebook: {layout: 'box_count'}";
		}
		if (socialShare.isShowTwitter()) {
			buttonOptions = addComma(buttonOptions);
			buttonOptions += "twitter: {count: 'vertical'}";
		}
		// if (socialShare.isShowDigg()) {
		// buttonOptions = addComma(buttonOptions);
		// buttonOptions += "digg: {type: 'DiggMedium'}";
		// }
		// if (socialShare.isShowDelicious()) {
		// buttonOptions = addComma(buttonOptions);
		// buttonOptions += "delicious: {size: 'tall'}";
		// }
		if (socialShare.isShowLinkedIn()) {
			buttonOptions = addComma(buttonOptions);
			buttonOptions += "linkedin: {counter: 'top'} ";
		}
		writer.write(buttonOptions);
		writer.write("}, \n");
		writer.write("enableHover: false, \n");
		writer.write("enableCounter: false, \n");
		writer.write("enableTracking: false \n");

		writer.write("}); }); \n");

		writer.endElement("script");

		writer.startElement("style", null);
		writer.writeAttribute("type", "text/css", "type\n");
		writer.write(".sharrre .button{\n");
		writer.write("float:left;\n");
		writer.write("width:60px;\n");
		writer.write("}\n");
		writer.endElement("style");
	}

	private void encodeLayout_2(FacesContext context, UISocialShare socialShare)
			throws IOException {

		ResponseWriter writer = context.getResponseWriter();
		String clientId = socialShare.getClientId(context).replace(":", "_");
		;
		String jqueryElementId = Utils.escapeIdForJQuery(clientId);

		writer.startElement("script", null);

		writer.write("pf_jQuery(function($) { \n");

		if (socialShare.isShowTwitter()) {
			writer.write("$('#" + jqueryElementId + "_twitter').sharrre({\n");
			writer.write("share: {\n");
			writer.write("twitter: true\n");
			writer.write("},\n");
			writer.write("enableHover: false,\n");
			writer.write("enableTracking: false,\n");
			writer.write("buttons: { twitter: {via: '_JulienH'}},\n");
			writer.write("click: function(api, options){\n");
			writer.write("api.simulateClick();\n");
			writer.write("api.openPopup('twitter');\n");
			writer.write("}\n");
			writer.write("});\n");
		}
		if (socialShare.isShowFacebook()) {
			writer.write("$('#" + jqueryElementId + "_facebook').sharrre({\n");
			writer.write("share: {\n");
			writer.write("facebook: true\n");
			writer.write("},\n");
			writer.write("enableHover: false,\n");
			writer.write("enableTracking: false,\n");
			writer.write("click: function(api, options){\n");
			writer.write("api.simulateClick();\n");
			writer.write("api.openPopup('facebook');\n");
			writer.write("}\n");
			writer.write("});\n");
		}

		// if (socialShare.isShowGooglePlus()) {
		// writer.write("$('#" + jqueryElementId + "_googleplus').sharrre({\n");
		// writer.write("share: {\n");
		// writer.write("googlePlus: true\n");
		// writer.write("},\n");
		// writer.write("enableHover: false,\n");
		// writer.write("enableTracking: false,\n");
		// writer.write("click: function(api, options){\n");
		// writer.write("api.simulateClick();\n");
		// writer.write("api.openPopup('googlePlus');\n");
		// writer.write("}\n");
		// writer.write("});\n");
		// }

		writer.write("}); \n");
		writer.endElement("script");

		writer.startElement("style", null);
		writer.writeAttribute("type", "text/css", "type\n");
		writer.write(".sharrre{\n");
		writer.write("margin:55px 0 0 50px;\n");
		writer.write("float:left;\n");
		writer.write("}\n");
		writer.write(".sharrre .box a:hover{\n");
		writer.write("text-decoration:none;\n");
		writer.write("}\n");
		writer.write(".sharrre .count {\n");
		writer.write("color:#525b67;\n");
		writer.write("display:block;\n");
		writer.write("font-size:18px;\n");
		writer.write("font-weight:bold;\n");
		writer.write("line-height:40px;\n");
		writer.write("height:40px;\n");
		writer.write("position:relative;\n");
		writer.write("text-align:center;\n");
		writer.write("width:70px;\n");
		writer.write("-webkit-border-radius:4px;\n");
		writer.write("-moz-border-radius:4px;\n");
		writer.write("border-radius:4px;\n");
		writer.write("border:1px solid #b2c6cc;\n");
		writer.write("background: #fbfbfb; /* Old browsers */\n");
		writer.write("background: -moz-linear-gradient(top, #fbfbfb 0%, #f6f6f6 100%); /* FF3.6+ */\n");
		writer.write("background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#fbfbfb), color-stop(100%,#f6f6f6)); /* Chrome,Safari4+ */\n");
		writer.write("background: -webkit-linear-gradient(top, #fbfbfb 0%,#f6f6f6 100%); /* Chrome10+,Safari5.1+ */\n");
		writer.write("background: -o-linear-gradient(top, #fbfbfb 0%,#f6f6f6 100%); /* Opera 11.10+ */\n");
		writer.write("background: -ms-linear-gradient(top, #fbfbfb 0%,#f6f6f6 100%); /* IE10+ */\n");
		writer.write("background: linear-gradient(top, #fbfbfb 0%,#f6f6f6 100%); /* W3C */\n");
		writer.write("filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#fbfbfb', endColorstr='#f6f6f6',GradientType=0 ); /* IE6-9 */\n");
		writer.write("}\n");
		writer.write(".sharrre .count:before, .sharrre .count:after {\n");
		writer.write("content:'';\n");
		writer.write("display:block;\n");
		writer.write("position:absolute;\n");
		writer.write("left:49%;\n");
		writer.write("width:0;\n");
		writer.write("height:0;\n");
		writer.write("}\n");
		writer.write(".sharrre .count:before {\n");
		writer.write("border:solid 7px transparent;\n");
		writer.write("border-top-color:#b2c6cc;\n");
		writer.write("margin-left:-7px;\n");
		writer.write("bottom: -14px;\n");
		writer.write("}\n");
		writer.write(".sharrre .count:after {\n");
		writer.write("border:solid 6px transparent;\n");
		writer.write("margin-left:-6px;\n");
		writer.write("bottom:-12px;\n");
		writer.write("border-top-color:#fbfbfb;\n");
		writer.write("}\n");
		writer.write(".sharrre .share {\n");
		writer.write("color:#FFFFFF;\n");
		writer.write("display:block;\n");
		writer.write("font-size:12px;\n");
		writer.write("font-weight:bold;\n");
		writer.write("height:30px;\n");
		writer.write("line-height:30px;\n");
		writer.write("margin-top:8px;\n");
		writer.write("padding:0;\n");
		writer.write("text-align:center;\n");
		writer.write("text-decoration:none;\n");
		writer.write("width:70px;\n");
		writer.write("-webkit-border-radius:4px;\n");
		writer.write("-moz-border-radius:4px;\n");
		writer.write("border-radius:4px;\n");
		writer.write("}\n");
		if (socialShare.isShowTwitter()) {
			writer.write("#" + clientId + "_twitter .share {\n");
			writer.write("text-shadow: 1px 0px 0px #0077be;\n");
			writer.write("filter: dropshadow(color=#0077be, offx=1, offy=0);\n");
			writer.write("border:1px solid #0075c5;\n");
			writer.write("background: #26c3eb;\n");
			writer.write("background: -moz-linear-gradient(top, #26c3eb 0%, #26b3e6 50%, #00a2e1 51%, #0080d6 100%); /* FF3.6+ */\n");
			writer.write("background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#26c3eb), color-stop(50%,#26b3e6), color-stop(51%,#00a2e1), color-stop(100%,#0080d6)); /* Chrome,Safari4+ */\n");
			writer.write("background: -webkit-linear-gradient(top, #26c3eb 0%,#26b3e6 50%,#00a2e1 51%,#0080d6 100%); /* Chrome10+,Safari5.1+ */\n");
			writer.write("background: -o-linear-gradient(top, #26c3eb 0%,#26b3e6 50%,#00a2e1 51%,#0080d6 100%); /* Opera 11.10+ */\n");
			writer.write("background: -ms-linear-gradient(top, #26c3eb 0%,#26b3e6 50%,#00a2e1 51%,#0080d6 100%); /* IE10+ */\n");
			writer.write("background: linear-gradient(top, #26c3eb 0%,#26b3e6 50%,#00a2e1 51%,#0080d6 100%); /* W3C */\n");
			writer.write("filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#26c3eb', endColorstr='#0080d6',GradientType=0 ); /* IE6-9 */\n");
			writer.write("box-shadow: 0 1px 4px #DDDDDD, 0 1px 0 #5cd3f1 inset;\n");
			writer.write("}\n");
		}
		if (socialShare.isShowFacebook()) {
			writer.write("#" + clientId + "_facebook .share {\n");
			writer.write("text-shadow: 1px 0px 0px #26427e;\n");
			writer.write("filter: dropshadow(color=#26427e, offx=1, offy=0);\n");
			writer.write("border:1px solid #24417c;\n");
			writer.write("background: #5582c9; /* Old browsers */\n");
			writer.write("background: -moz-linear-gradient(top, #5582c9 0%, #33539a 100%); /* FF3.6+ */\n");
			writer.write("background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#5582c9), color-stop(100%,#33539a)); /* Chrome,Safari4+ */\n");
			writer.write("background: -webkit-linear-gradient(top, #5582c9 0%,#33539a 100%); /* Chrome10+,Safari5.1+ */\n");
			writer.write("background: -o-linear-gradient(top, #5582c9 0%,#33539a 100%); /* Opera 11.10+ */\n");
			writer.write("background: -ms-linear-gradient(top, #5582c9 0%,#33539a 100%); /* IE10+ */\n");
			writer.write("background: linear-gradient(top, #5582c9 0%,#33539a 100%); /* W3C */\n");
			writer.write("filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#5582c9', endColorstr='#33539a',GradientType=0 ); /* IE6-9 */\n");
			writer.write("box-shadow: 0 1px 4px #DDDDDD, 0 1px 0 #80a1d6 inset;\n");
			writer.write("}\n");
		}
		// if (socialShare.isShowGooglePlus()) {
		// writer.write("#" + clientId + "_googleplus .share {\n");
		// writer.write("text-shadow: 1px 0px 0px #222222;\n");
		// writer.write("filter: dropshadow(color=#222222, offx=1, offy=0);\n");
		// writer.write("border:1px solid #262626;\n");
		// writer.write("background: #6d6d6d; /* Old browsers */\n");
		// writer.write("background: -moz-linear-gradient(top, #6d6d6d 0%, #434343 100%); /* FF3.6+ */\n");
		// writer.write("background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#6d6d6d), color-stop(100%,#434343)); /* Chrome,Safari4+ */\n");
		// writer.write("background: -webkit-linear-gradient(top, #6d6d6d 0%,#434343 100%); /* Chrome10+,Safari5.1+ */\n");
		// writer.write("background: -o-linear-gradient(top, #6d6d6d 0%,#434343 100%); /* Opera 11.10+ */\n");
		// writer.write("background: -ms-linear-gradient(top, #6d6d6d 0%,#434343 100%); /* IE10+ */\n");
		// writer.write("background: linear-gradient(top, #6d6d6d 0%,#434343 100%); /* W3C */\n");
		// writer.write("filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#6d6d6d', endColorstr='#434343',GradientType=0 ); /* IE6-9 */\n");
		// writer.write("box-shadow: 0 1px 4px #DDDDDD, 0 1px 0 #929292 inset;\n");
		// writer.write("}\n");
		// }

		writer.endElement("style");
	}

	private void encodeLayout_3(FacesContext context, UISocialShare socialShare)
			throws IOException {

		ResponseWriter writer = context.getResponseWriter();
		String clientId = socialShare.getClientId(context).replace(":", "_");
		
		String jqueryElementId = Utils.escapeIdForJQuery(clientId);

		writer.startElement("script", null);

		writer.write("pf_jQuery(function($) { \n");

		if (socialShare.isShowTwitter()) {
			writer.write("$('#" + jqueryElementId + "_twitter').sharrre({\n");
			writer.write("share: {\n");
			writer.write("twitter: true\n");
			writer.write("},\n");
			writer.write("template: '<a class='box' href='#'><div class='count' href='#'>{total}</div><div class='share'><span></span>Tweet</div></a>',\n");
			writer.write("enableHover: false,\n");
			writer.write("enableTracking: false,\n");
			writer.write("buttons: { twitter: {via: '_JulienH'}},\n");
			writer.write("click: function(api, options){\n");
			writer.write("api.simulateClick();\n");
			writer.write("api.openPopup('twitter');\n");
			writer.write("}\n");
			writer.write("});\n");
		}
		if (socialShare.isShowFacebook()) {
			writer.write("$('#" + jqueryElementId + "_facebook').sharrre({\n");
			writer.write("share: {\n");
			writer.write("facebook: true\n");
			writer.write("},\n");
			writer.write("template: '<a class='box' href='#'><div class='count' href='#'>{total}</div><div class='share'><span></span>Tweet</div></a>',\n");
			writer.write("enableHover: false,\n");
			writer.write("enableTracking: false,\n");
			writer.write("click: function(api, options){\n");
			writer.write("api.simulateClick();\n");
			writer.write("api.openPopup('facebook');\n");
			writer.write("}\n");
			writer.write("});\n");
		}
		// if (socialShare.isShowGooglePlus()) {
		// writer.write("$('#" + jqueryElementId + "_googleplus').sharrre({\n");
		// writer.write("share: {\n");
		// writer.write("googlePlus: true\n");
		// writer.write("},\n");
		// writer.write("template: '<a class='box' href='#'><div class='count' href='#'>{total}</div><div class='share'><span></span>Tweet</div></a>',\n");
		// writer.write("enableHover: false,\n");
		// writer.write("enableTracking: true,\n");
		// writer.write("click: function(api, options){\n");
		// writer.write("api.simulateClick();\n");
		// writer.write("api.openPopup('googlePlus');\n");
		// writer.write("}\n");
		// writer.write("});\n");
		// }

		writer.write("}); \n");
		writer.endElement("script");

		writer.startElement("style", null);
		writer.writeAttribute("type", "text/css", "type\n");
		writer.write(" .sharrre{\n");
		writer.write("margin:55px 0 0 50px;\n");
		writer.write("float:left;\n");
		writer.write("}\n");
		writer.write(".sharrre .box{\n");
		writer.write("float:left;\n");
		writer.write("width:80px;\n");
		writer.write("height:75px;\n");
		writer.write("-webkit-border-radius:7px;\n");
		writer.write("-moz-border-radius:7px;\n");
		writer.write("border-radius:7px;\n");
		writer.write("-webkit-box-shadow:0 1px 0 #C3C3C3, 0 6px 0 #54a2bc, 0px 2px 3px 0px rgba(47, 58, 61, 0.25), inset 0px 1px 0px 0px rgba(255, 255, 255, 1);\n");
		writer.write("-moz-box-shadow:0 1px 0 #C3C3C3, 0 6px 0 #54a2bc, 0px 2px 3px 0px rgba(47, 58, 61, 0.25), inset 0px 1px 0px 0px rgba(255, 255, 255, 1);\n");
		writer.write("box-shadow:0 1px 0 #C3C3C3, 0 6px 0 #54a2bc, 0px 2px 3px 0px rgba(47, 58, 61, 0.25), inset 0px 2px 0px 0px rgba(255, 255, 255, 1);\n");
		writer.write("background: #dee7ea; /* Old browsers */\n");
		writer.write("background: -moz-linear-gradient(top, #dee7ea 0%, #e5eef2 20%, #e5eef2 100%); /* FF3.6+ */\n");
		writer.write("background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#dee7ea), color-stop(20%,#e5eef2), color-stop(100%,#e5eef2)); /* Chrome,Safari4+ */\n");
		writer.write("background: -webkit-linear-gradient(top, #dee7ea 0%,#e5eef2 20%,#e5eef2 100%); /* Chrome10+,Safari5.1+ */\n");
		writer.write("background: -o-linear-gradient(top, #dee7ea 0%,#e5eef2 20%,#e5eef2 100%); /* Opera 11.10+ */\n");
		writer.write("background: -ms-linear-gradient(top, #dee7ea 0%,#e5eef2 20%,#e5eef2 100%); /* IE10+ */\n");
		writer.write("background: linear-gradient(top, #dee7ea 0%,#e5eef2 20%,#e5eef2 100%); /* W3C */\n");
		writer.write("filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#dee7ea', endColorstr='#e5eef2',GradientType=0 ); /* IE6-9 */\n");
		writer.write("}\n");

		writer.write(".sharrre .box:active, " + "#" + clientId + "_facebook .box:active, " + "#" + clientId + "_googleplus .box:active{\n");
		writer.write("box-shadow:0 0 3px #333333;\n");
		writer.write("margin-top:4px;\n");
		writer.write("}\n");
		writer.write(".sharrre .count, .sharrre .share{\n");
		writer.write("display:inline-block;\n");
		writer.write("width:78px;\n");
		writer.write("text-align:center;\n");
		writer.write("font-weight:bold;\n");
		writer.write("}\n");
		writer.write(".sharrre .count{\n");
		writer.write("font-size:20px;\n");
		writer.write("color:#444444;\n");
		writer.write("text-shadow: 0px 1px 0px #ffffff;\n");
		writer.write("filter: dropshadow(color=#ffffff, offx=0, offy=1);\n");
		writer.write("height:40px;\n");
		writer.write("line-height:40px;\n");
		writer.write("border:1px solid #b9b9b9;\n");
		writer.write("border-width:1px 1px 0 1px;\n");
		writer.write("-moz-border-radius-topleft:7px;\n");
		writer.write("-moz-border-radius-topright:7px;\n");
		writer.write("-moz-border-radius-bottomright:0;\n");
		writer.write("-moz-border-radius-bottomleft:0;\n");
		writer.write("-webkit-border-radius:7px 7px 0 0;\n");
		writer.write("border-radius:7px 7px 0 0;\n");
		writer.write("position:relative;\n");
		writer.write("}\n");
		writer.write(".sharrre .count:before, .sharrre .count:after {\n");
		writer.write("content:'';\n");
		writer.write("display:block;\n");
		writer.write("position:absolute;\n");
		writer.write("left:49%;\n");
		writer.write("width:0;\n");
		writer.write("height:0;\n");
		writer.write("}\n");
		writer.write(".sharrre .count:before {\n");
		writer.write("border:solid 7px transparent;\n");
		writer.write("border-top-color:#b2c6cc;\n");
		writer.write("margin-left:-7px;\n");
		writer.write("bottom: -14px;\n");
		writer.write("}\n");
		writer.write(".sharrre .count:after {\n");
		writer.write("border:solid 6px transparent;\n");
		writer.write("margin-left:-6px;\n");
		writer.write("bottom:-12px;\n");
		writer.write("border-top-color:#e5eef2;\n");
		writer.write("}\n");
		writer.write(".sharrre .share{\n");
		writer.write("height:34px;\n");
		writer.write("line-height:34px;\n");
		writer.write("color:#ffffff;\n");
		writer.write("font-size:13px;\n");
		writer.write("text-shadow: 0px 1px 0px rgba(0, 0, 0, 0.35);\n");
		writer.write("filter: dropshadow(color=#d1d1d1, offx=0, offy=1);\n");
		writer.write("border:1px solid #6fa4b5;\n");
		writer.write("border-width:0 1px 1px 1px;\n");
		writer.write("-moz-border-radius-topleft:0;\n");
		writer.write("-moz-border-radius-topright:0;\n");
		writer.write("-moz-border-radius-bottomright:7px;\n");
		writer.write("-moz-border-radius-bottomleft:7px;\n");
		writer.write("-webkit-border-radius:0 0 7px 7px;\n");
		writer.write("border-radius:0 0 7px 7px;\n");
		writer.write("background-color:#7ac5df;\n");
		writer.write("-webkit-box-shadow:inset 0px 1px 0px 0px rgba(105, 164, 185, 1), inset 0px -1px 2px 0px rgba(255, 255, 255, 0.6), inset 0px 2px 1px 0px rgba(255, 0, 0, 0.15);\n");
		writer.write("-moz-box-shadow:inset 0px 1px 0px 0px rgba(105, 164, 185, 1), inset 0px -1px 2px 0px rgba(255, 255, 255, 0.6), inset 0px 2px 1px 0px rgba(255, 0, 0, 0.15);\n");
		writer.write("box-shadow:inset 0px 1px 0px 0px rgba(105, 164, 185, 1), inset 0px -1px 2px 0px rgba(255, 255, 255, 0.6), inset 0px 2px 1px 0px rgba(255, 0, 0, 0.15);\n");
		writer.write("}\n");
		writer.write(".sharrre .share span{\n");
		// #{resource['images:shareme_3.png']}
		writer.write("background:url("
				// very stupid hardcoding
				+ context.getExternalContext().getRequestContextPath()
				+ "/javax.faces.resource/shareme_3.png.jsf?ln=images"
				+ ") no-repeat scroll 0 0 transparent;\n");
		writer.write("width:18px;\n");
		writer.write("height:10px;\n");
		writer.write("display: inline-block;\n");
		writer.write("}\n");

		if (socialShare.isShowFacebook()) {
			writer.write("#" + clientId + "_facebook .box{\n");
			writer.write("-webkit-box-shadow:0 1px 0 #C3C3C3, 0 6px 0 #28437a, 0px 2px 3px 0px rgba(47, 58, 61, 0.25), inset 0px 1px 0px 0px rgba(255, 255, 255, 1);\n");
			writer.write("-moz-box-shadow:0 1px 0 #C3C3C3, 0 6px 0 #28437a, 0px 2px 3px 0px rgba(47, 58, 61, 0.25), inset 0px 1px 0px 0px rgba(255, 255, 255, 1);\n");
			writer.write("box-shadow:0 1px 0 #C3C3C3, 0 6px 0 #28437a, 0px 2px 3px 0px rgba(47, 58, 61, 0.25), inset 0px 2px 0px 0px rgba(255, 255, 255, 1);\n");
			writer.write("}\n");

			writer.write("#" + clientId + "_facebook .share span{\n");
			writer.write("background-position:0 -35px;\n");
			writer.write("height:12px;\n");
			writer.write("}\n");
			writer.write("#" + clientId + "_facebook .share {\n");
			writer.write("border-color:#35538f;\n");
			writer.write("background: #637fbb; /* Old browsers */\n");
			writer.write("background: -moz-linear-gradient(top, #637fbb 0%, #49649e 100%); /* FF3.6+ */\n");
			writer.write("background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#637fbb), color-stop(100%,#49649e)); /* Chrome,Safari4+ */\n");
			writer.write("background: -webkit-linear-gradient(top, #637fbb 0%,#49649e 100%); /* Chrome10+,Safari5.1+ */\n");
			writer.write("background: -o-linear-gradient(top, #637fbb 0%,#49649e 100%); /* Opera 11.10+ */\n");
			writer.write("background: -ms-linear-gradient(top, #637fbb 0%,#49649e 100%); /* IE10+ */\n");
			writer.write("background: linear-gradient(top, #637fbb 0%,#49649e 100%); /* W3C */\n");
			writer.write("filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#637fbb', endColorstr='#49649e',GradientType=0 ); /* IE6-9 */\n");
			writer.write("-webkit-box-shadow:inset 0px 1px 0px 0px rgba(74, 95, 138, 1), inset 0px -1px 2px 0px rgba(255, 255, 255, 0.4), inset 0px 2px 1px 0px rgba(255, 0, 0, 0.15);\n");
			writer.write("-moz-box-shadow:inset 0px 1px 0px 0px rgba(74, 95, 138, 1), inset 0px -1px 2px 0px rgba(255, 255, 255, 0.4), inset 0px 2px 1px 0px rgba(255, 0, 0, 0.15);\n");
			writer.write("box-shadow:inset 0px 1px 0px 0px rgba(74, 95, 138, 1), inset 0px -1px 2px 0px rgba(255, 255, 255, 0.4), inset 0px 2px 1px 0px rgba(255, 0, 0, 0.15);\n");
			writer.write("}\n");
		}
		// if (socialShare.isShowGooglePlus()) {
		// writer.write("#" + clientId + "_googleplus .box{\n");
		// writer.write("-webkit-box-shadow:0 1px 0 #C3C3C3, 0 6px 0 #404040, 0px 2px 3px 0px rgba(47, 58, 61, 0.25), inset 0px 1px 0px 0px rgba(255, 255, 255, 1);\n");
		// writer.write("-moz-box-shadow:0 1px 0 #C3C3C3, 0 6px 0 #404040, 0px 2px 3px 0px rgba(47, 58, 61, 0.25), inset 0px 1px 0px 0px rgba(255, 255, 255, 1);\n");
		// writer.write("box-shadow:0 1px 0 #C3C3C3, 0 6px 0 #404040, 0px 2px 3px 0px rgba(47, 58, 61, 0.25), inset 0px 2px 0px 0px rgba(255, 255, 255, 1);\n");
		// writer.write("}\n");
		// writer.write("#" + clientId + "_googleplus .share {\n");
		// writer.write("border-color:#303030;\n");
		// writer.write("background: #626263; /* Old browsers */\n");
		// writer.write("background: -moz-linear-gradient(top, #626263 0%, #424244 100%); /* FF3.6+ */\n");
		// writer.write("background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#626263), color-stop(100%,#424244)); /* Chrome,Safari4+ */\n");
		// writer.write("background: -webkit-linear-gradient(top, #626263 0%,#424244 100%); /* Chrome10+,Safari5.1+ */\n");
		// writer.write("background: -o-linear-gradient(top, #626263 0%,#424244 100%); /* Opera 11.10+ */\n");
		// writer.write("background: -ms-linear-gradient(top, #626263 0%,#424244 100%); /* IE10+ */\n");
		// writer.write("background: linear-gradient(top, #626263 0%,#424244 100%); /* W3C */\n");
		// writer.write("filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#626263', endColorstr='#424244',GradientType=0 ); /* IE6-9 */\n");
		// writer.write("-webkit-box-shadow:inset 0px 1px 0px 0px rgba(74, 95, 138, 1), inset 0px -1px 2px 0px rgba(255, 255, 255, 0.4), inset 0px 2px 1px 0px rgba(255, 0, 0, 0.15);\n");
		// writer.write("-moz-box-shadow:inset 0px 1px 0px 0px rgba(74, 95, 138, 1), inset 0px -1px 2px 0px rgba(255, 255, 255, 0.4), inset 0px 2px 1px 0px rgba(255, 0, 0, 0.15);\n");
		// writer.write("box-shadow:inset 0px 1px 0px 0px rgba(74, 95, 138, 1), inset 0px -1px 2px 0px rgba(255, 255, 255, 0.4), inset 0px 2px 1px 0px rgba(255, 0, 0, 0.15);\n");
		// writer.write("}\n");
		// }

		writer.endElement("style");
	}
}